/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 
 */
@ApiModel(description = "")

public class CatalogQueryRange {
  @JsonProperty("attribute_name")
  private String attributeName = null;

  @JsonProperty("attribute_min_value")
  private Long attributeMinValue = null;

  @JsonProperty("attribute_max_value")
  private Long attributeMaxValue = null;

  public CatalogQueryRange attributeName(String attributeName) {
    this.attributeName = attributeName;
    return this;
  }

   /**
   * The name of the attribute to be searched.
   * @return attributeName
  **/
  @ApiModelProperty(required = true, value = "The name of the attribute to be searched.")
  public String getAttributeName() {
    return attributeName;
  }

  public void setAttributeName(String attributeName) {
    this.attributeName = attributeName;
  }

  public CatalogQueryRange attributeMinValue(Long attributeMinValue) {
    this.attributeMinValue = attributeMinValue;
    return this;
  }

   /**
   * The desired minimum value for the search attribute (inclusive).
   * @return attributeMinValue
  **/
  @ApiModelProperty(value = "The desired minimum value for the search attribute (inclusive).")
  public Long getAttributeMinValue() {
    return attributeMinValue;
  }

  public void setAttributeMinValue(Long attributeMinValue) {
    this.attributeMinValue = attributeMinValue;
  }

  public CatalogQueryRange attributeMaxValue(Long attributeMaxValue) {
    this.attributeMaxValue = attributeMaxValue;
    return this;
  }

   /**
   * The desired maximum value for the search attribute (inclusive).
   * @return attributeMaxValue
  **/
  @ApiModelProperty(value = "The desired maximum value for the search attribute (inclusive).")
  public Long getAttributeMaxValue() {
    return attributeMaxValue;
  }

  public void setAttributeMaxValue(Long attributeMaxValue) {
    this.attributeMaxValue = attributeMaxValue;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CatalogQueryRange catalogQueryRange = (CatalogQueryRange) o;
    return Objects.equals(this.attributeName, catalogQueryRange.attributeName) &&
        Objects.equals(this.attributeMinValue, catalogQueryRange.attributeMinValue) &&
        Objects.equals(this.attributeMaxValue, catalogQueryRange.attributeMaxValue);
  }

  @Override
  public int hashCode() {
    return Objects.hash(attributeName, attributeMinValue, attributeMaxValue);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CatalogQueryRange {\n");
    
    sb.append("    attributeName: ").append(toIndentedString(attributeName)).append("\n");
    sb.append("    attributeMinValue: ").append(toIndentedString(attributeMinValue)).append("\n");
    sb.append("    attributeMaxValue: ").append(toIndentedString(attributeMaxValue)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

