/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * The hourly wage rate used to compensate an employee for this shift.
 */
@ApiModel(description = "The hourly wage rate used to compensate an employee for this shift.")

public class ShiftWage {
  @JsonProperty("title")
  private String title = null;

  @JsonProperty("hourly_rate")
  private Money hourlyRate = null;

  public ShiftWage title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The name of the job performed during this shift. Square labor-reporting UIs may group shifts together by title.
   * @return title
  **/
  @ApiModelProperty(value = "The name of the job performed during this shift. Square labor-reporting UIs may group shifts together by title.")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ShiftWage hourlyRate(Money hourlyRate) {
    this.hourlyRate = hourlyRate;
    return this;
  }

   /**
   * Can be a custom-set hourly wage or the calculated effective hourly wage based on annual wage and hours worked per week.
   * @return hourlyRate
  **/
  @ApiModelProperty(value = "Can be a custom-set hourly wage or the calculated effective hourly wage based on annual wage and hours worked per week.")
  public Money getHourlyRate() {
    return hourlyRate;
  }

  public void setHourlyRate(Money hourlyRate) {
    this.hourlyRate = hourlyRate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ShiftWage shiftWage = (ShiftWage) o;
    return Objects.equals(this.title, shiftWage.title) &&
        Objects.equals(this.hourlyRate, shiftWage.hourlyRate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, hourlyRate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ShiftWage {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    hourlyRate: ").append(toIndentedString(hourlyRate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

