/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 
 */
@ApiModel(description = "")

public class V1ListEmployeesRequest {
  /**
   * The order in which employees are listed in the response, based on their created_at field.      Default value: ASC See [SortOrder](#type-sortorder) for possible values
   */
  public enum OrderEnum {
    DESC("DESC"),
    
    ASC("ASC");

    private String value;

    OrderEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static OrderEnum fromValue(String text) {
      for (OrderEnum b : OrderEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("order")
  private OrderEnum order = null;

  @JsonProperty("begin_updated_at")
  private String beginUpdatedAt = null;

  @JsonProperty("end_updated_at")
  private String endUpdatedAt = null;

  @JsonProperty("begin_created_at")
  private String beginCreatedAt = null;

  @JsonProperty("end_created_at")
  private String endCreatedAt = null;

  /**
   * If provided, the endpoint returns only employee entities with the specified status (ACTIVE or INACTIVE). See [V1ListEmployeesRequestStatus](#type-v1listemployeesrequeststatus) for possible values
   */
  public enum StatusEnum {
    ACTIVE("ACTIVE"),
    
    INACTIVE("INACTIVE");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("external_id")
  private String externalId = null;

  @JsonProperty("limit")
  private Integer limit = null;

  @JsonProperty("batch_token")
  private String batchToken = null;

  public V1ListEmployeesRequest order(OrderEnum order) {
    this.order = order;
    return this;
  }

   /**
   * The order in which employees are listed in the response, based on their created_at field.      Default value: ASC See [SortOrder](#type-sortorder) for possible values
   * @return order
  **/
  @ApiModelProperty(value = "The order in which employees are listed in the response, based on their created_at field.      Default value: ASC See [SortOrder](#type-sortorder) for possible values")
  public OrderEnum getOrder() {
    return order;
  }

  public void setOrder(OrderEnum order) {
    this.order = order;
  }

  public V1ListEmployeesRequest beginUpdatedAt(String beginUpdatedAt) {
    this.beginUpdatedAt = beginUpdatedAt;
    return this;
  }

   /**
   * If filtering results by their updated_at field, the beginning of the requested reporting period, in ISO 8601 format
   * @return beginUpdatedAt
  **/
  @ApiModelProperty(value = "If filtering results by their updated_at field, the beginning of the requested reporting period, in ISO 8601 format")
  public String getBeginUpdatedAt() {
    return beginUpdatedAt;
  }

  public void setBeginUpdatedAt(String beginUpdatedAt) {
    this.beginUpdatedAt = beginUpdatedAt;
  }

  public V1ListEmployeesRequest endUpdatedAt(String endUpdatedAt) {
    this.endUpdatedAt = endUpdatedAt;
    return this;
  }

   /**
   * If filtering results by there updated_at field, the end of the requested reporting period, in ISO 8601 format.
   * @return endUpdatedAt
  **/
  @ApiModelProperty(value = "If filtering results by there updated_at field, the end of the requested reporting period, in ISO 8601 format.")
  public String getEndUpdatedAt() {
    return endUpdatedAt;
  }

  public void setEndUpdatedAt(String endUpdatedAt) {
    this.endUpdatedAt = endUpdatedAt;
  }

  public V1ListEmployeesRequest beginCreatedAt(String beginCreatedAt) {
    this.beginCreatedAt = beginCreatedAt;
    return this;
  }

   /**
   * If filtering results by their created_at field, the beginning of the requested reporting period, in ISO 8601 format.
   * @return beginCreatedAt
  **/
  @ApiModelProperty(value = "If filtering results by their created_at field, the beginning of the requested reporting period, in ISO 8601 format.")
  public String getBeginCreatedAt() {
    return beginCreatedAt;
  }

  public void setBeginCreatedAt(String beginCreatedAt) {
    this.beginCreatedAt = beginCreatedAt;
  }

  public V1ListEmployeesRequest endCreatedAt(String endCreatedAt) {
    this.endCreatedAt = endCreatedAt;
    return this;
  }

   /**
   * If filtering results by their created_at field, the end of the requested reporting period, in ISO 8601 format.
   * @return endCreatedAt
  **/
  @ApiModelProperty(value = "If filtering results by their created_at field, the end of the requested reporting period, in ISO 8601 format.")
  public String getEndCreatedAt() {
    return endCreatedAt;
  }

  public void setEndCreatedAt(String endCreatedAt) {
    this.endCreatedAt = endCreatedAt;
  }

  public V1ListEmployeesRequest status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * If provided, the endpoint returns only employee entities with the specified status (ACTIVE or INACTIVE). See [V1ListEmployeesRequestStatus](#type-v1listemployeesrequeststatus) for possible values
   * @return status
  **/
  @ApiModelProperty(value = "If provided, the endpoint returns only employee entities with the specified status (ACTIVE or INACTIVE). See [V1ListEmployeesRequestStatus](#type-v1listemployeesrequeststatus) for possible values")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public V1ListEmployeesRequest externalId(String externalId) {
    this.externalId = externalId;
    return this;
  }

   /**
   * If provided, the endpoint returns only employee entities with the specified external_id.
   * @return externalId
  **/
  @ApiModelProperty(value = "If provided, the endpoint returns only employee entities with the specified external_id.")
  public String getExternalId() {
    return externalId;
  }

  public void setExternalId(String externalId) {
    this.externalId = externalId;
  }

  public V1ListEmployeesRequest limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * The maximum integer number of employee entities to return in a single response. Default 100, maximum 200.
   * @return limit
  **/
  @ApiModelProperty(value = "The maximum integer number of employee entities to return in a single response. Default 100, maximum 200.")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public V1ListEmployeesRequest batchToken(String batchToken) {
    this.batchToken = batchToken;
    return this;
  }

   /**
   * A pagination cursor to retrieve the next set of results for your original query to the endpoint.
   * @return batchToken
  **/
  @ApiModelProperty(value = "A pagination cursor to retrieve the next set of results for your original query to the endpoint.")
  public String getBatchToken() {
    return batchToken;
  }

  public void setBatchToken(String batchToken) {
    this.batchToken = batchToken;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    V1ListEmployeesRequest v1ListEmployeesRequest = (V1ListEmployeesRequest) o;
    return Objects.equals(this.order, v1ListEmployeesRequest.order) &&
        Objects.equals(this.beginUpdatedAt, v1ListEmployeesRequest.beginUpdatedAt) &&
        Objects.equals(this.endUpdatedAt, v1ListEmployeesRequest.endUpdatedAt) &&
        Objects.equals(this.beginCreatedAt, v1ListEmployeesRequest.beginCreatedAt) &&
        Objects.equals(this.endCreatedAt, v1ListEmployeesRequest.endCreatedAt) &&
        Objects.equals(this.status, v1ListEmployeesRequest.status) &&
        Objects.equals(this.externalId, v1ListEmployeesRequest.externalId) &&
        Objects.equals(this.limit, v1ListEmployeesRequest.limit) &&
        Objects.equals(this.batchToken, v1ListEmployeesRequest.batchToken);
  }

  @Override
  public int hashCode() {
    return Objects.hash(order, beginUpdatedAt, endUpdatedAt, beginCreatedAt, endCreatedAt, status, externalId, limit, batchToken);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class V1ListEmployeesRequest {\n");
    
    sb.append("    order: ").append(toIndentedString(order)).append("\n");
    sb.append("    beginUpdatedAt: ").append(toIndentedString(beginUpdatedAt)).append("\n");
    sb.append("    endUpdatedAt: ").append(toIndentedString(endUpdatedAt)).append("\n");
    sb.append("    beginCreatedAt: ").append(toIndentedString(beginCreatedAt)).append("\n");
    sb.append("    endCreatedAt: ").append(toIndentedString(endCreatedAt)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    externalId: ").append(toIndentedString(externalId)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    batchToken: ").append(toIndentedString(batchToken)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

