/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Sets the Day of the week and hour of the day that a business starts a  work week. Used for the calculation of overtime pay.
 */
@ApiModel(description = "Sets the Day of the week and hour of the day that a business starts a  work week. Used for the calculation of overtime pay.")

public class WorkweekConfig {
  @JsonProperty("id")
  private String id = null;

  /**
   * The day of the week on which a business week cuts over for compensation purposes.
   */
  public enum StartOfWeekEnum {
    MON("MON"),
    
    TUE("TUE"),
    
    WED("WED"),
    
    THU("THU"),
    
    FRI("FRI"),
    
    SAT("SAT"),
    
    SUN("SUN");

    private String value;

    StartOfWeekEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StartOfWeekEnum fromValue(String text) {
      for (StartOfWeekEnum b : StartOfWeekEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("start_of_week")
  private StartOfWeekEnum startOfWeek = null;

  @JsonProperty("start_of_day_local_time")
  private String startOfDayLocalTime = null;

  @JsonProperty("version")
  private Integer version = null;

  @JsonProperty("created_at")
  private String createdAt = null;

  @JsonProperty("updated_at")
  private String updatedAt = null;

  public WorkweekConfig id(String id) {
    this.id = id;
    return this;
  }

   /**
   * UUID for this object
   * @return id
  **/
  @ApiModelProperty(value = "UUID for this object")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public WorkweekConfig startOfWeek(StartOfWeekEnum startOfWeek) {
    this.startOfWeek = startOfWeek;
    return this;
  }

   /**
   * The day of the week on which a business week cuts over for compensation purposes.
   * @return startOfWeek
  **/
  @ApiModelProperty(required = true, value = "The day of the week on which a business week cuts over for compensation purposes.")
  public StartOfWeekEnum getStartOfWeek() {
    return startOfWeek;
  }

  public void setStartOfWeek(StartOfWeekEnum startOfWeek) {
    this.startOfWeek = startOfWeek;
  }

  public WorkweekConfig startOfDayLocalTime(String startOfDayLocalTime) {
    this.startOfDayLocalTime = startOfDayLocalTime;
    return this;
  }

   /**
   * The local time at which a business week cuts over. Represented as a string in `HH:MM` format (`HH:MM:SS` is also accepted, but seconds are truncated).
   * @return startOfDayLocalTime
  **/
  @ApiModelProperty(required = true, value = "The local time at which a business week cuts over. Represented as a string in `HH:MM` format (`HH:MM:SS` is also accepted, but seconds are truncated).")
  public String getStartOfDayLocalTime() {
    return startOfDayLocalTime;
  }

  public void setStartOfDayLocalTime(String startOfDayLocalTime) {
    this.startOfDayLocalTime = startOfDayLocalTime;
  }

  public WorkweekConfig version(Integer version) {
    this.version = version;
    return this;
  }

   /**
   * Used for resolving concurrency issues; request will fail if version provided does not match server version at time of request. If not provided, Square executes a blind write; potentially overwriting data from another write.
   * @return version
  **/
  @ApiModelProperty(value = "Used for resolving concurrency issues; request will fail if version provided does not match server version at time of request. If not provided, Square executes a blind write; potentially overwriting data from another write.")
  public Integer getVersion() {
    return version;
  }

  public void setVersion(Integer version) {
    this.version = version;
  }

  public WorkweekConfig createdAt(String createdAt) {
    this.createdAt = createdAt;
    return this;
  }

   /**
   * A read-only timestamp in RFC 3339 format; presented in UTC
   * @return createdAt
  **/
  @ApiModelProperty(value = "A read-only timestamp in RFC 3339 format; presented in UTC")
  public String getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(String createdAt) {
    this.createdAt = createdAt;
  }

  public WorkweekConfig updatedAt(String updatedAt) {
    this.updatedAt = updatedAt;
    return this;
  }

   /**
   * A read-only timestamp in RFC 3339 format; presented in UTC
   * @return updatedAt
  **/
  @ApiModelProperty(value = "A read-only timestamp in RFC 3339 format; presented in UTC")
  public String getUpdatedAt() {
    return updatedAt;
  }

  public void setUpdatedAt(String updatedAt) {
    this.updatedAt = updatedAt;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WorkweekConfig workweekConfig = (WorkweekConfig) o;
    return Objects.equals(this.id, workweekConfig.id) &&
        Objects.equals(this.startOfWeek, workweekConfig.startOfWeek) &&
        Objects.equals(this.startOfDayLocalTime, workweekConfig.startOfDayLocalTime) &&
        Objects.equals(this.version, workweekConfig.version) &&
        Objects.equals(this.createdAt, workweekConfig.createdAt) &&
        Objects.equals(this.updatedAt, workweekConfig.updatedAt);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, startOfWeek, startOfDayLocalTime, version, createdAt, updatedAt);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WorkweekConfig {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    startOfWeek: ").append(toIndentedString(startOfWeek)).append("\n");
    sb.append("    startOfDayLocalTime: ").append(toIndentedString(startOfDayLocalTime)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    updatedAt: ").append(toIndentedString(updatedAt)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

